<?php

namespace Nwb\MultiDownloaderClient;

class FileRequest
{
    /**
     * @var string
     */
    private $url;
    /**
     * @var string
     */
    private $fallbackUrl;
    /**
     * @var FileOptions
     */
    private $fileOptions;

    public function __construct(string $url, string $fallbackUrl = null)
    {
        $this->url = $url;
        $this->fallbackUrl = $fallbackUrl;

        $this->fileOptions = new FileOptions();
    }

    public function url(string $url)
    {
        $this->url = $url;

        return $this;
    }

    public function fallbackUrl(string $fallbackUrl)
    {
        $this->fallbackUrl = $fallbackUrl;

        return $this;
    }

    public function fileOptions(FileOptions $fileOptions)
    {
        $this->fileOptions = $fileOptions;

        return $this;
    }

    public function getFileOptions(): FileOptions
    {
        return $this->fileOptions;
    }

    public function getUrl(): string
    {
        return $this->url;
    }

    public function getFallbackUrl(): string
    {
        return $this->fallbackUrl;
    }

    public function toArray(): array
    {
        return array_filter([
            'url' => $this->url,
            'fallbackUrl' => $this->fallbackUrl,
            'fileOptions' => $this->fileOptions->toArray(),
        ]);
    }
}
